<?php
/*
Plugin Name: Super Classy
Plugin URI: http://trepmal.com/plugins/adding-more-classes-to-wp_list_pages/
Description: Add an assortment of depth-related classes to wp_nav_menu's, wp_list_pages's, wp_list_categories's output
Author: Kailey Lampert
Version: 1.1
Author URI: http://kaileylampert.com/
*/
/*
    Copyright (C) 2010  Kailey Lampert

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


$superclassy = new superclassy();

class superclassy {

	function superclassy() {

		add_filter('wp_list_pages', array(&$this, 'reprint'));
		add_filter('wp_list_categories', array(&$this, 'reprint'));
		add_filter('wp_nav_menu', array(&$this, 'reprint'));
	
	}
	
	function add_classes($object,$pf='') {
		$pf .= '_';
		$str = '';
		foreach($object as $k => $v) {
			//$class =  (string) $v->attributes('class');
			$class =  (string) $v->attributes()->class;
			$href =  $v->attributes()->href;
			$title =  $v->attributes()->title;
			$id =  $v->attributes()->id;
			 
			if($class == 'pagenav' || $class == 'categories') $pf = substr($pf,1);//if there's a title li, adjust the depth
			
			if (is_array($v->li->attributes() ) ) {
				$liclass = $v->li->attributes();
				$liclass = $liclass['class'];
				//$liclass = (string) $v->li->attributes()->class;
				if( $liclass == 'pagenav' || $liclass == 'categories')  $pf = substr($pf,1);  //if there's a title li, adjust the depth
			}
			
			$depth = strlen($pf); //convert prefix to number
			if ($depth < 1) {$depth == '0';}
			else $depth = ($depth%2 == 0) ? $depth/2 : (($depth/2)-.5);
			
			if($k == 'div') $pf = ''; //custom menus start with <div>, skip that when applying classes
			if($k == 'ul') ++$depth; //make the ul match its nested elements
			 
			if(isset($liclass) && ($liclass == 'pagenav' || $liclass == 'categories')) --$depth;//if there's a title li, adjust the depth
			$newclass = (empty($class) ? '' : $class.' ') . 'level-'.$depth.'-'.$k;
	
			$other = ''; //start getting other atts
			$other .= empty($href) ? '' : ' href="'.$href.'"';
			$other .= empty($title) ? '' : ' title="'.$title.'"';
			$other .= empty($id) ? '' : ' id="'.$id.'"';
			
			$str .= '<'.$k.' class="'.$newclass.'"'.$other.'>';
	
			$str .= $v; //tag with classes, other atts, and content
			$str .= $this->add_classes($v,$pf);
	
			$str .= '</'.$k.'>'; //loop for nested items
			
		}
		return $str;
	}
	
	function reprint($list) {
	
		$pages_wrapped = $list;
		$pages_wrapped = str_replace("\n",'',$pages_wrapped);
		$pages_wrapped = str_replace("\t",'',$pages_wrapped);
		if(substr($pages_wrapped,0,3) == '<li') $pages_wrapped = '<ul class="tmpwrp">'.$pages_wrapped.'</ul>';//add this to make sure we get proper depth measurments
		
		$fauxml_pages = '<?xml version="1.0" encoding="UTF-8" ?><menu>'.utf8_encode($pages_wrapped).'</menu>';
		$xml_pages = simplexml_load_string($fauxml_pages);
	
		$menu = $this->add_classes($xml_pages);
	
		// remove the wrapping ul we added a bit earlier
		$menu = preg_replace('(<ul class=\"tmpwrp level-[0-9?]-ul\">)','',$menu);
	
		if (substr($menu,-5) == '</ul>')	$menu = substr($menu,0,-5).'<!-- ~~ -->';
	
		return $menu;
	}

}

?>